export class Game {
    currentCard;
    currentPlayer;
    players;
    isReverse = false;
    isGameOver = false;
    winners = [];
    constructor(players, firstCard, startingPlayer) {
        this.players = players;
        this.currentCard = firstCard;
        this.currentPlayer = startingPlayer;
    }
    getState() {
        return {
            currentCard: this.currentCard,
            currentPlayer: this.currentPlayer,
            isReverse: this.isReverse,
            isGameOver: this.isGameOver,
            winners: this.winners,
        };
    }
    getCurrentPlayer() {
        return this.currentPlayer;
    }
    getCurrentCard() {
        return this.currentCard;
    }
    getPlayers() {
        return [...this.players];
    }
    setCurrentCard(card) {
        this.currentCard = card;
    }
    toggleDirection() {
        this.isReverse = !this.isReverse;
    }
    addWinner(player) {
        this.winners.push(player);
        this.checkGameOver();
    }
    checkGameOver() {
        // Game is over when all but one player has finished
        if (this.winners.length >= this.players.length - 1) {
            this.isGameOver = true;
        }
    }
}
//# sourceMappingURL=Game.js.map