export class TurnManager {
    players;
    currentPlayerIndex;
    isReverse;
    constructor(players, startingPlayerIndex = 0) {
        this.players = [...players];
        this.currentPlayerIndex = startingPlayerIndex;
        this.isReverse = false;
    }
    getCurrentPlayer() {
        return this.players[this.currentPlayerIndex];
    }
    nextTurn(playedCard) {
        if (playedCard?.getValue() === "reverse") {
            this.isReverse = !this.isReverse;
        }
        if (playedCard?.getValue() === "skip") {
            this.currentPlayerIndex = this.getNextPlayerIndex();
        }
        this.currentPlayerIndex = this.getNextPlayerIndex();
    }
    getNextPlayerIndex() {
        const nextIndex = this.isReverse
            ? this.currentPlayerIndex - 1
            : this.currentPlayerIndex + 1;
        if (nextIndex >= this.players.length) {
            return 0;
        }
        if (nextIndex < 0) {
            return this.players.length - 1;
        }
        return nextIndex;
    }
    isReversed() {
        return this.isReverse;
    }
}
//# sourceMappingURL=TurnManager.js.map